Subject: Re: Improved copy_page() function, about 30% speed up for mpc860!

From: Daniel Jacobowitz <[email-masked]>
Date: Mon, 3 Mar 2003 19:54:05 -0500

On Mon, Mar 03, 2003 at 07:43:08PM -0500, Dan Malek wrote:
> Joakim Tjernlund wrote:
>
> >OK so this is not it then, but what is it then? Are you 100% that
> >the bug(whatever this may be) is present for mpc860, rev D4 or later?
> >How can I make it bite me on kernel space memory?
> >I can't find that info in the archives, if it's there please give me a
> >hint.
>
> I guess once again I don't understand the questions or failed to express
> my responses properly.
>
> In the previous message, you included a link that indicated a problem
> setting the DAR, cache instructions, and asked if this was a problem.
> In this case, due to the way we map kernel space and use the cache
> instructions,
> we have "fixed" this bug.  I believe it was found because of the way we
> copy instructions in the C library, and it affected user applications.
> The specific problem described in this link is not a problem with Linux.

That is, in fact, incorrect.  It's fatal from userland.  I experimented
with it just a couple of months ago.

Only way to sort it out would be to do instruction decoding on the
faulting address, which is hideous beyond words.

--
Daniel Jacobowitz
MontaVista Software                         Debian GNU/Linux Developer

** Sent via the linuxppc-dev mail list. See http://lists.linuxppc.org/